gtkmm: Gtk::CellRendererSpinner Class Reference

gtkmm 3.24.11

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gtk::CellRendererSpinner Class Reference
TreeView Classes

Renders a spinning animation in a cell. More...

`#include <gtkmm/cellrendererspinner.h>`

Inheritance diagram for Gtk::CellRendererSpinner:
[legend]

## Public Member Functions
| CellRendererSpinner (CellRendererSpinner && src) noexcept
CellRendererSpinner & | operator= (CellRendererSpinner && src) noexcept
| CellRendererSpinner (const CellRendererSpinner &)=delete
CellRendererSpinner & | operator= (const CellRendererSpinner &)=delete
| ~CellRendererSpinner () noexcept override
GtkCellRendererSpinner * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellRendererSpinner * | gobj () const
| Provides access to the underlying C GObject.
| CellRendererSpinner ()
Glib::PropertyProxy< bool > | property_active ()
| Whether the spinner is active (ie.
Glib::PropertyProxy_ReadOnly< bool > | property_active () const
| Whether the spinner is active (ie.
Glib::PropertyProxy< guint > | property_pulse ()
| Pulse of the spinner.
Glib::PropertyProxy_ReadOnly< guint > | property_pulse () const
| Pulse of the spinner.
Glib::PropertyProxy< Gtk::IconSize > | property_size ()
| The Gtk::IconSize value that specifies the size of the rendered spinner.
Glib::PropertyProxy_ReadOnly< Gtk::IconSize > | property_size () const
| The Gtk::IconSize value that specifies the size of the rendered spinner.
Public Member Functions inherited from Gtk::CellRenderer
| CellRenderer (CellRenderer && src) noexcept
CellRenderer & | operator= (CellRenderer && src) noexcept
| CellRenderer (const CellRenderer &)=delete
CellRenderer & | operator= (const CellRenderer &)=delete
| ~CellRenderer () noexcept override
GtkCellRenderer * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellRenderer * | gobj () const
| Provides access to the underlying C GObject.
SizeRequestMode | get_request_mode () const
| Gets whether the cell renderer prefers a height-for-width layout or a width-for-height layout.
void | get_preferred_width (Widget & widget, int & minimum_width, int & natural_width) const
| Retreives a renderer’s natural size when rendered to widget.
void | get_preferred_height_for_width (Widget & widget, int width, int & minimum_height, int & natural_height) const
| Retreives a cell renderers’s minimum and natural height if it were rendered to widget with the specified width.
void | get_preferred_height (Widget & widget, int & minimum_height, int & natural_height) const
| Retreives a renderer’s natural size when rendered to widget.
void | get_preferred_width_for_height (Widget & widget, int height, int & minimum_width, int & natural_width) const
| Retreives a cell renderers’s minimum and natural width if it were rendered to widget with the specified height.
void | get_preferred_size (Widget & widget, Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a cell taking into account the widget’s preference for height-for-width management.
void | get_aligned_area (Widget & widget, CellRendererState flags, const Gdk::Rectangle & cell_area, Gdk::Rectangle & aligned_area)
| Gets the aligned area used by cell inside cell_area.
void | render (const ::Cairo::RefPtr< ::Cairo::Context > & cr, Widget & widget, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
| Invokes the virtual render function of the Gtk::CellRenderer.
bool | activate (GdkEvent * event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
| Passes an activate event to the cell renderer for possible processing.
CellEditable * | start_editing (GdkEvent * event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags=CellRendererState(0))
| Starts editing the contents of this cell, through a new Gtk::CellEditable widget created by the Gtk::CellRendererClass.start_editing virtual function.
void | set_fixed_size (int width, int height)
| Sets the renderer size to be explicit, independent of the properties set.
void | get_fixed_size (int & width, int & height) const
| Fills in width and height with the appropriate size of cell.
void | set_alignment (float xalign, float yalign)
| Sets the renderer’s alignment within its available space.
void | get_alignment (float & xalign, float & yalign) const
| Fills in xalign and yalign with the appropriate values of cell.
void | set_padding (int xpad, int ypad)
| Sets the renderer’s padding.
void | get_padding (int & xpad, int & ypad) const
| Fills in xpad and ypad with the appropriate values of cell.
void | set_visible (bool visible=true)
| Sets the cell renderer’s visibility.
bool | get_visible () const
| Returns the cell renderer’s visibility.
void | set_sensitive (bool sensitive=true)
| Sets the cell renderer’s sensitivity.
bool | get_sensitive () const
| Returns the cell renderer’s sensitivity.
bool | is_activatable () const
| Checks whether the cell renderer can do something when activated.
void | stop_editing (bool canceled=false)
| Informs the cell renderer that the editing is stopped.
StateFlags | get_state (Widget & widget, CellRendererState cell_state) const
| Translates the cell renderer state to Gtk::StateFlags, based on the cell renderer and widget sensitivity, and the given Gtk::CellRendererState.
StateFlags | get_state (CellRendererState cell_state) const
| Translates the cell renderer state to StateFlags, based on the cell renderer and the given CellRendererState.
Glib::SignalProxy< void > | signal_editing_canceled ()
Glib::SignalProxy< void, CellEditable *, const Glib::ustring & > | signal_editing_started ()
Glib::PropertyProxy< CellRendererMode > | property_mode ()
| Editable mode of the CellRenderer.
Glib::PropertyProxy_ReadOnly< CellRendererMode > | property_mode () const
| Editable mode of the CellRenderer.
Glib::PropertyProxy< bool > | property_visible ()
| Display the cell.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Display the cell.
Glib::PropertyProxy< bool > | property_sensitive ()
| Display the cell sensitive.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Display the cell sensitive.
Glib::PropertyProxy< float > | property_xalign ()
| The x-align.
Glib::PropertyProxy_ReadOnly< float > | property_xalign () const
| The x-align.
Glib::PropertyProxy< float > | property_yalign ()
| The y-align.
Glib::PropertyProxy_ReadOnly< float > | property_yalign () const
| The y-align.
Glib::PropertyProxy< unsigned int > | property_xpad ()
| The xpad.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_xpad () const
| The xpad.
Glib::PropertyProxy< unsigned int > | property_ypad ()
| The ypad.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_ypad () const
| The ypad.
Glib::PropertyProxy< int > | property_width ()
| The fixed width.
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| The fixed width.
Glib::PropertyProxy< int > | property_height ()
| The fixed height.
Glib::PropertyProxy_ReadOnly< int > | property_height () const
| The fixed height.
Glib::PropertyProxy< bool > | property_is_expander ()
| Row has children.
Glib::PropertyProxy_ReadOnly< bool > | property_is_expander () const
| Row has children.
Glib::PropertyProxy< bool > | property_is_expanded ()
| Row is an expander row, and is expanded.
Glib::PropertyProxy_ReadOnly< bool > | property_is_expanded () const
| Row is an expander row, and is expanded.
Glib::PropertyProxy_WriteOnly< Glib::ustring > | property_cell_background ()
| Cell background color as a string.
Glib::PropertyProxy< Gdk::Color > | property_cell_background_gdk ()
| Cell background as a Gdk::Color.
Glib::PropertyProxy_ReadOnly< Gdk::Color > | property_cell_background_gdk () const
| Cell background as a Gdk::Color.
Glib::PropertyProxy< Gdk::RGBA > | property_cell_background_rgba ()
| Cell background as a Gdk::RGBA.
Glib::PropertyProxy_ReadOnly< Gdk::RGBA > | property_cell_background_rgba () const
| Cell background as a Gdk::RGBA.
Glib::PropertyProxy< bool > | property_cell_background_set ()
| Whether the cell background color is set.
Glib::PropertyProxy_ReadOnly< bool > | property_cell_background_set () const
| Whether the cell background color is set.
Glib::PropertyProxy_ReadOnly< bool > | property_editing () const
| Whether the cell renderer is currently in editing mode.
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::CellRenderer
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Gtk::CellRendererSpinner * | wrap (GtkCellRendererSpinner * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::CellRenderer
Gtk::CellRenderer * | wrap (GtkCellRenderer * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Gtk::CellRenderer
virtual void | on_editing_canceled ()
| This is a default handler for the signal signal_editing_canceled().
virtual void | on_editing_started (CellEditable * editable, const Glib::ustring & path)
| This is a default handler for the signal signal_editing_started().
| CellRenderer ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (Widget & widget, int & minimum_width, int & natural_width) const
virtual void | get_preferred_height_for_width_vfunc (Widget & widget, int width, int & minimum_height, int & natural_height) const
virtual void | get_preferred_height_vfunc (Widget & widget, int & minimum_height, int & natural_height) const
virtual void | get_preferred_width_for_height_vfunc (Widget & widget, int height, int & minimum_width, int & natural_width) const
virtual void | render_vfunc (const ::Cairo::RefPtr< ::Cairo::Context > & cr, Widget & widget, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
virtual bool | activate_vfunc (GdkEvent * event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
virtual CellEditable * | start_editing_vfunc (GdkEvent * event, Widget & widget, const Glib::ustring & path, const Gdk::Rectangle & background_area, const Gdk::Rectangle & cell_area, CellRendererState flags)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

Renders a spinning animation in a cell.

A CellRendererSpinner can be used as an alternative to CellRendererProgress for displaying indefinite activity, instead of actual progress.

To start the animation in a cell, set the active property to true and increment the pulse property at regular intervals.

## Constructor & Destructor Documentation

## ◆ CellRendererSpinner() [1/3]

Gtk::CellRendererSpinner::CellRendererSpinner | ( | CellRendererSpinner && | src | ) |
| noexcept

## ◆ CellRendererSpinner() [2/3]

Gtk::CellRendererSpinner::CellRendererSpinner | ( | const CellRendererSpinner & |  | ) |
| delete

## ◆ ~CellRendererSpinner()

Gtk::CellRendererSpinner::~CellRendererSpinner | ( |  | ) |
| overridenoexcept

## ◆ CellRendererSpinner() [3/3]

Gtk::CellRendererSpinner::CellRendererSpinner | ( |  | ) |

## Member Function Documentation

## ◆ get_type()

GType Gtk::CellRendererSpinner::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkCellRendererSpinner * Gtk::CellRendererSpinner::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkCellRendererSpinner * Gtk::CellRendererSpinner::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=() [1/2]

CellRendererSpinner & Gtk::CellRendererSpinner::operator= | ( | CellRendererSpinner && | src | ) |
| noexcept

## ◆ operator=() [2/2]

CellRendererSpinner & Gtk::CellRendererSpinner::operator= | ( | const CellRendererSpinner & |  | ) |
| delete

## ◆ property_active() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRendererSpinner::property_active | ( |  | ) |

Whether the spinner is active (ie.

shown) in the cell.

Default value: false

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_active() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRendererSpinner::property_active | ( |  | ) | const

Whether the spinner is active (ie.

shown) in the cell.

Default value: false

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_pulse() [1/2]

Glib::PropertyProxy< guint > Gtk::CellRendererSpinner::property_pulse | ( |  | ) |

Pulse of the spinner.

Increment this value to draw the next frame of the spinner animation. Usually, you would update this value in a timeout.

By default, the Gtk::Spinner widget draws one full cycle of the animation, consisting of 12 frames, in 750 milliseconds.

Since gtkmm 2.20

Default value: 0

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_pulse() [2/2]

Glib::PropertyProxy_ReadOnly< guint > Gtk::CellRendererSpinner::property_pulse | ( |  | ) | const

Pulse of the spinner.

Increment this value to draw the next frame of the spinner animation. Usually, you would update this value in a timeout.

By default, the Gtk::Spinner widget draws one full cycle of the animation, consisting of 12 frames, in 750 milliseconds.

Since gtkmm 2.20

Default value: 0

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_size() [1/2]

Glib::PropertyProxy< Gtk::IconSize > Gtk::CellRendererSpinner::property_size | ( |  | ) |

The Gtk::IconSize value that specifies the size of the rendered spinner.

Since gtkmm 2.20

Default value: Gtk::ICON_SIZE_MENU

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_size() [2/2]

Glib::PropertyProxy_ReadOnly< Gtk::IconSize > Gtk::CellRendererSpinner::property_size | ( |  | ) | const

The Gtk::IconSize value that specifies the size of the rendered spinner.

Since gtkmm 2.20

Default value: Gtk::ICON_SIZE_MENU

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::CellRendererSpinner * wrap | ( | GtkCellRendererSpinner * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.